bm::bv_statistics Struct Reference
BitMagic Library » bvector<> container

Structure with statistical information about memory allocation footprint, serialization projection, number of vectors. More...

`#include <bmfunc.h>`

Inheritance diagram for bm::bv_statistics:
[legend]

## Public Member Functions

| bv_statistics () BMNOEXCEPT
void | add_bit_block () BMNOEXCEPT
| cound bit block
void | add_gap_block (unsigned capacity, unsigned length, unsigned level) BMNOEXCEPT
| count gap block
void | reset () BMNOEXCEPT
| Reset statisctics.
void | add (const bv_statistics &st) BMNOEXCEPT
| Sum data from another sttructure.

## Data Fields

size_t | bit_blocks
| Number of bit blocks.
size_t | gap_blocks
| Number of GAP blocks.
size_t | ptr_sub_blocks
| Number of sub-blocks.
size_t | bv_count
| Number of bit-vectors.
size_t | max_serialize_mem
| estimated maximum memory for serialization
size_t | memory_used
| memory usage for all blocks and service tables
size_t | gap_cap_overhead
| gap memory overhead between length and capacity
gap_word_t | gap_levels [bm::gap_levels]
| GAP block lengths in the bvect.
unsigned long long | gaps_by_level [bm::gap_levels]
| number of GAP blocks at each level

## Detailed Description

Structure with statistical information about memory allocation footprint, serialization projection, number of vectors.

Definition at line 55 of file bmfunc.h.

## Constructor & Destructor Documentation

## bv_statistics()

bm::bv_statistics::bv_statistics | ( |  | ) |

inline

Definition at line 67 of file bmfunc.h.

References BMNOEXCEPT, and reset().

Referenced by add().

## Member Function Documentation

## add()

void bm::bv_statistics::add | ( | const bv_statistics & | st | ) |

inline

Sum data from another sttructure.

Definition at line 103 of file bmfunc.h.

References bit_blocks, BMNOEXCEPT, bv_count, bv_statistics(), gap_blocks, gap_cap_overhead, max_serialize_mem, memory_used, and ptr_sub_blocks.

Referenced by bm::basic_bmatrix< BV >::calc_stat(), bm::base_sparse_vector< Val, BV, MAX_SIZE >::optimize(), bm::basic_bmatrix< BV >::optimize(), bm::sparse_vector< Val, BV >::optimize(), and bm::str_sparse_vector< CharType, BV, STR_SIZE >::optimize().

## add_bit_block()

void bm::bv_statistics::add_bit_block | ( |  | ) |

inline

cound bit block

Definition at line 70 of file bmfunc.h.

References bit_blocks, BMNOEXCEPT, max_serialize_mem, memory_used, and bm::set_block_size.

## add_gap_block()

void bm::bv_statistics::add_gap_block | ( | unsigned | capacity,
|  | unsigned | length,
|  | unsigned | level )

inline

count gap block

Definition at line 79 of file bmfunc.h.

References BM_ASSERT, BMNOEXCEPT, gap_blocks, gap_cap_overhead, bm::gap_levels, gaps_by_level, max_serialize_mem, and memory_used.

## reset()

void bm::bv_statistics::reset | ( |  | ) |

inline

Reset statisctics.

Definition at line 94 of file bmfunc.h.

References bit_blocks, BMNOEXCEPT, bv_count, gap_blocks, gap_cap_overhead, bm::gap_levels, gaps_by_level, max_serialize_mem, memory_used, and ptr_sub_blocks.

Referenced by bm::optimize_plan_builder< SVect, Lock >::build_plan(), bv_statistics(), bm::basic_bmatrix< BV >::optimize(), bm::bvector< Alloc >::optimize(), and bm::sparse_vector< Val, BV >::optimize().

## Field Documentation

## bit_blocks

size_t bm::bv_statistics::bit_blocks

Number of bit blocks.

Examples
  sample11.cpp, sample26.cpp, sample3.cpp, and sample4.cpp.

Definition at line 57 of file bmfunc.h.

Referenced by add(), add_bit_block(), bm::str_sparse_vector< CharType, BV, STR_SIZE >::calc_stat(), generate_bvector(), print_statistics(), print_statistics(), print_statistics(), reset(), and serialize_bvector().

## bv_count

size_t bm::bv_statistics::bv_count

Number of bit-vectors.

Definition at line 60 of file bmfunc.h.

Referenced by add(), bm::str_sparse_vector< CharType, BV, STR_SIZE >::calc_stat(), and reset().

## gap_blocks

size_t bm::bv_statistics::gap_blocks

Number of GAP blocks.

Examples
  sample11.cpp, sample26.cpp, sample3.cpp, and sample4.cpp.

Definition at line 58 of file bmfunc.h.

Referenced by add(), add_gap_block(), bm::str_sparse_vector< CharType, BV, STR_SIZE >::calc_stat(), generate_bvector(), print_statistics(), print_statistics(), print_statistics(), reset(), and serialize_bvector().

## gap_cap_overhead

size_t bm::bv_statistics::gap_cap_overhead

gap memory overhead between length and capacity

Examples
  sample26.cpp.

Definition at line 63 of file bmfunc.h.

Referenced by add(), add_gap_block(), bm::str_sparse_vector< CharType, BV, STR_SIZE >::calc_stat(), print_statistics(), and reset().

## gap_levels

gap_word_t bm::bv_statistics::gap_levels[bm::gap_levels]

GAP block lengths in the bvect.

Definition at line 64 of file bmfunc.h.

Referenced by bm::bvector< Alloc >::optimize().

## gaps_by_level

unsigned long long bm::bv_statistics::gaps_by_level[bm::gap_levels]

number of GAP blocks at each level

Definition at line 65 of file bmfunc.h.

Referenced by add_gap_block(), and reset().

## max_serialize_mem

size_t bm::bv_statistics::max_serialize_mem

estimated maximum memory for serialization

Examples
  sample26.cpp, sample3.cpp, sample4.cpp, xsample01.cpp, and xsample07a.cpp.

Definition at line 61 of file bmfunc.h.

Referenced by add(), add_bit_block(), add_gap_block(), bm::str_sparse_vector< CharType, BV, STR_SIZE >::calc_stat(), convert_bv2bvs(), generate_k_mers(), bm::bvector< Alloc >::optimize(), print_statistics(), print_statistics(), print_statistics(), reset(), bm::serializer< BV >::serialize(), and serialize_bvector().

## memory_used

size_t bm::bv_statistics::memory_used

memory usage for all blocks and service tables

Examples
  sample26.cpp, sample3.cpp, sample4.cpp, and xsample01.cpp.

Definition at line 62 of file bmfunc.h.

Referenced by add(), add_bit_block(), add_gap_block(), calc_memory_footprint(), bm::str_sparse_vector< CharType, BV, STR_SIZE >::calc_stat(), bm::bvector< Alloc >::optimize(), bm::rsc_sparse_vector< Val, SV >::optimize(), print_statistics(), print_statistics(), print_statistics(), reset(), and serialize_bvector().

## ptr_sub_blocks

size_t bm::bv_statistics::ptr_sub_blocks

Number of sub-blocks.

Definition at line 59 of file bmfunc.h.

Referenced by add(), bm::str_sparse_vector< CharType, BV, STR_SIZE >::calc_stat(), and reset().

The documentation for this struct was generated from the following file:

- bmfunc.h